// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr'

#ifndef RTDDataHdr_H
#define RTDDataHdr_H

#ifdef PRAGMA
#pragma interface "RTDDataHdr.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
#include <RTDEncodingFormat.h>
#include <RTDMessageType.h>

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class RTDDataHdr
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'msgType'
	RTDMessageType msgType;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'localId'
	unsigned long localId;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'localCycle'
	unsigned long localCycle;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'remoteId'
	unsigned long remoteId;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'remoteCycle'
	unsigned long remoteCycle;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'dataVersion'
	unsigned long dataVersion;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'msgPriority'
	short msgPriority;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'dataFormat'
	unsigned char dataFormat;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'dataFlag'
	unsigned char dataFlag;
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'MSGDESTMASK'
	static const unsigned char MSGDESTMASK;
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'USER_MSG'
	static const unsigned char USER_MSG;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'TRANSPORTER_MSG'
	static const unsigned char TRANSPORTER_MSG;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'CONTROLLER_MSG'
	static const unsigned char CONTROLLER_MSG;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'REMOTEPORT_MSG'
	static const unsigned char REMOTEPORT_MSG;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' classAttribute 'sourceAId'
	unsigned long sourceAId;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' tool 'OT::Cpp' property 'GenerateDefaultConstructor'
	RTDDataHdr( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~RTDDataHdr( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' operation 'isTransporterMsg()'
	inline int isTransporterMsg( void ) const
	{
		// {{{USR operation 'isTransporterMsg()'
		return ((dataFlag & MSGDESTMASK) == TRANSPORTER_MSG);
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' operation 'isControllerMsg()'
	inline int isControllerMsg( void ) const
	{
		// {{{USR operation 'isControllerMsg()'
		return ((dataFlag & MSGDESTMASK) == CONTROLLER_MSG);
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' operation 'isRemotePortMsg()'
	inline int isRemotePortMsg( void ) const
	{
		// {{{USR operation 'isRemotePortMsg()'
		return ((dataFlag & MSGDESTMASK) == REMOTEPORT_MSG);
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' operation 'isUserMsg()'
	inline int isUserMsg( void ) const
	{
		// {{{USR operation 'isUserMsg()'
		return ((dataFlag & MSGDESTMASK) == USER_MSG);
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' operation 'isSpecialtyMsg()'
	inline int isSpecialtyMsg( void ) const
	{
		// {{{USR operation 'isSpecialtyMsg()'
		return !isUserMsg();
		// }}}USR
	}
	// }}}RME
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMessages::RTDDataHdr' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDDataHdr_H */

// }}}RME
