// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDInitStatus'

#ifndef RTDInitStatus_H
#define RTDInitStatus_H

#ifdef PRAGMA
#pragma interface "RTDInitStatus.h"
#endif

#include <RTSystem/DCS.h>

struct RTDInitStatus
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_rtdDCSrunningReply = rtiLast_RTRootProtocol + 1,
			rti_rtdCDMportReply,
			rti_rtdORBrunningReply,
			rti_rtdORBhandleReply,
			rti_rtdVClimitReply,
			rti_rtdAgentActiveReply,
			rti_rtdLocatorAvailableReply,
			rti_rtdTransportControllerReply,
			rti_rtdPrimaryEndpointReply,
			rti_rtdBackupEndpointReply
		};

	protected:
		enum { rtiLast_RTDInitStatus = rti_rtdBackupEndpointReply };

	public:
		inline RTInSignal rtdDCSrunningReply( void );
		inline RTInSignal rtdCDMportReply( void );
		inline RTInSignal rtdORBrunningReply( void );
		inline RTInSignal rtdORBhandleReply( void );
		inline RTInSignal rtdVClimitReply( void );
		inline RTInSignal rtdAgentActiveReply( void );
		inline RTInSignal rtdLocatorAvailableReply( void );
		inline RTInSignal rtdTransportControllerReply( void );
		inline RTInSignal rtdPrimaryEndpointReply( void );
		inline RTInSignal rtdBackupEndpointReply( void );
		inline RTOutSignal rtdDCSrunning( const RTTypedValue & value );
		inline RTOutSignal rtdDCSrunning( void );
		inline RTOutSignal rtdCDMport( const RTTypedValue & value );
		inline RTOutSignal rtdCDMport( void );
		inline RTOutSignal rtdORBrunning( const RTTypedValue & value );
		inline RTOutSignal rtdORBrunning( void );
		inline RTOutSignal rtdORBhandle( const RTTypedValue & value );
		inline RTOutSignal rtdORBhandle( void );
		inline RTOutSignal rtdVClimit( const RTTypedValue & value );
		inline RTOutSignal rtdVClimit( void );
		inline RTOutSignal rtdAgentActive( const RTTypedValue & value );
		inline RTOutSignal rtdAgentActive( void );
		inline RTOutSignal rtdLocatorAvailable( const RTTypedValue & value );
		inline RTOutSignal rtdLocatorAvailable( void );
		inline RTOutSignal rtdTransportController( const RTTypedValue & value );
		inline RTOutSignal rtdTransportController( void );
		inline RTOutSignal rtdPrimaryEndpoint( const RTTypedValue_RTString & data );
		inline RTOutSignal rtdBackupEndpoint( const RTTypedValue_RTString & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_rtdDCSrunning = rtiLast_RTRootProtocol + 1,
			rti_rtdCDMport,
			rti_rtdORBrunning,
			rti_rtdORBhandle,
			rti_rtdVClimit,
			rti_rtdAgentActive,
			rti_rtdLocatorAvailable,
			rti_rtdTransportController,
			rti_rtdPrimaryEndpoint,
			rti_rtdBackupEndpoint
		};

	protected:
		enum { rtiLast_RTDInitStatus = rti_rtdBackupEndpoint };

	public:
		inline RTInSignal rtdDCSrunning( void );
		inline RTInSignal rtdCDMport( void );
		inline RTInSignal rtdORBrunning( void );
		inline RTInSignal rtdORBhandle( void );
		inline RTInSignal rtdVClimit( void );
		inline RTInSignal rtdAgentActive( void );
		inline RTInSignal rtdLocatorAvailable( void );
		inline RTInSignal rtdTransportController( void );
		inline RTInSignal rtdPrimaryEndpoint( void );
		inline RTInSignal rtdBackupEndpoint( void );
		inline RTOutSignal rtdDCSrunningReply( const int & data );
		inline RTOutSignal rtdCDMportReply( const int & data );
		inline RTOutSignal rtdORBrunningReply( const int & data );
		inline RTOutSignal rtdORBhandleReply( const long & data );
		inline RTOutSignal rtdVClimitReply( const int & data );
		inline RTOutSignal rtdAgentActiveReply( const int & data );
		inline RTOutSignal rtdLocatorAvailableReply( const int & data );
		inline RTOutSignal rtdTransportControllerReply( const long & data );
		inline RTOutSignal rtdPrimaryEndpointReply( const int & data );
		inline RTOutSignal rtdBackupEndpointReply( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline RTDInitStatus::Base::Base( void )
	: RTRootProtocol()
{
}

inline RTDInitStatus::Base::~Base( void )
{
}

inline RTInSignal RTDInitStatus::Base::rtdDCSrunningReply( void )
{
	return RTInSignal( this, rti_rtdDCSrunningReply );
}

inline RTInSignal RTDInitStatus::Base::rtdCDMportReply( void )
{
	return RTInSignal( this, rti_rtdCDMportReply );
}

inline RTInSignal RTDInitStatus::Base::rtdORBrunningReply( void )
{
	return RTInSignal( this, rti_rtdORBrunningReply );
}

inline RTInSignal RTDInitStatus::Base::rtdORBhandleReply( void )
{
	return RTInSignal( this, rti_rtdORBhandleReply );
}

inline RTInSignal RTDInitStatus::Base::rtdVClimitReply( void )
{
	return RTInSignal( this, rti_rtdVClimitReply );
}

inline RTInSignal RTDInitStatus::Base::rtdAgentActiveReply( void )
{
	return RTInSignal( this, rti_rtdAgentActiveReply );
}

inline RTInSignal RTDInitStatus::Base::rtdLocatorAvailableReply( void )
{
	return RTInSignal( this, rti_rtdLocatorAvailableReply );
}

inline RTInSignal RTDInitStatus::Base::rtdTransportControllerReply( void )
{
	return RTInSignal( this, rti_rtdTransportControllerReply );
}

inline RTInSignal RTDInitStatus::Base::rtdPrimaryEndpointReply( void )
{
	return RTInSignal( this, rti_rtdPrimaryEndpointReply );
}

inline RTInSignal RTDInitStatus::Base::rtdBackupEndpointReply( void )
{
	return RTInSignal( this, rti_rtdBackupEndpointReply );
}

inline RTOutSignal RTDInitStatus::Base::rtdDCSrunning( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdDCSrunning, value.data, value.type );
}

inline RTOutSignal RTDInitStatus::Base::rtdDCSrunning( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdDCSrunning, (void *)0, &RTType_void );
}

inline RTOutSignal RTDInitStatus::Base::rtdCDMport( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdCDMport, value.data, value.type );
}

inline RTOutSignal RTDInitStatus::Base::rtdCDMport( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdCDMport, (void *)0, &RTType_void );
}

inline RTOutSignal RTDInitStatus::Base::rtdORBrunning( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdORBrunning, value.data, value.type );
}

inline RTOutSignal RTDInitStatus::Base::rtdORBrunning( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdORBrunning, (void *)0, &RTType_void );
}

inline RTOutSignal RTDInitStatus::Base::rtdORBhandle( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdORBhandle, value.data, value.type );
}

inline RTOutSignal RTDInitStatus::Base::rtdORBhandle( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdORBhandle, (void *)0, &RTType_void );
}

inline RTOutSignal RTDInitStatus::Base::rtdVClimit( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdVClimit, value.data, value.type );
}

inline RTOutSignal RTDInitStatus::Base::rtdVClimit( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdVClimit, (void *)0, &RTType_void );
}

inline RTOutSignal RTDInitStatus::Base::rtdAgentActive( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdAgentActive, value.data, value.type );
}

inline RTOutSignal RTDInitStatus::Base::rtdAgentActive( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdAgentActive, (void *)0, &RTType_void );
}

inline RTOutSignal RTDInitStatus::Base::rtdLocatorAvailable( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdLocatorAvailable, value.data, value.type );
}

inline RTOutSignal RTDInitStatus::Base::rtdLocatorAvailable( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdLocatorAvailable, (void *)0, &RTType_void );
}

inline RTOutSignal RTDInitStatus::Base::rtdTransportController( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdTransportController, value.data, value.type );
}

inline RTOutSignal RTDInitStatus::Base::rtdTransportController( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdTransportController, (void *)0, &RTType_void );
}

inline RTOutSignal RTDInitStatus::Base::rtdPrimaryEndpoint( const RTTypedValue_RTString & data )
{
	return RTOutSignal( this, Conjugate::rti_rtdPrimaryEndpoint, data.data, data.type );
}

inline RTOutSignal RTDInitStatus::Base::rtdBackupEndpoint( const RTTypedValue_RTString & data )
{
	return RTOutSignal( this, Conjugate::rti_rtdBackupEndpoint, data.data, data.type );
}

inline RTDInitStatus::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline RTDInitStatus::Conjugate::~Conjugate( void )
{
}

inline RTInSignal RTDInitStatus::Conjugate::rtdDCSrunning( void )
{
	return RTInSignal( this, rti_rtdDCSrunning );
}

inline RTInSignal RTDInitStatus::Conjugate::rtdCDMport( void )
{
	return RTInSignal( this, rti_rtdCDMport );
}

inline RTInSignal RTDInitStatus::Conjugate::rtdORBrunning( void )
{
	return RTInSignal( this, rti_rtdORBrunning );
}

inline RTInSignal RTDInitStatus::Conjugate::rtdORBhandle( void )
{
	return RTInSignal( this, rti_rtdORBhandle );
}

inline RTInSignal RTDInitStatus::Conjugate::rtdVClimit( void )
{
	return RTInSignal( this, rti_rtdVClimit );
}

inline RTInSignal RTDInitStatus::Conjugate::rtdAgentActive( void )
{
	return RTInSignal( this, rti_rtdAgentActive );
}

inline RTInSignal RTDInitStatus::Conjugate::rtdLocatorAvailable( void )
{
	return RTInSignal( this, rti_rtdLocatorAvailable );
}

inline RTInSignal RTDInitStatus::Conjugate::rtdTransportController( void )
{
	return RTInSignal( this, rti_rtdTransportController );
}

inline RTInSignal RTDInitStatus::Conjugate::rtdPrimaryEndpoint( void )
{
	return RTInSignal( this, rti_rtdPrimaryEndpoint );
}

inline RTInSignal RTDInitStatus::Conjugate::rtdBackupEndpoint( void )
{
	return RTInSignal( this, rti_rtdBackupEndpoint );
}

inline RTOutSignal RTDInitStatus::Conjugate::rtdDCSrunningReply( const int & data )
{
	return RTOutSignal( this, Base::rti_rtdDCSrunningReply, &data, &RTType_int );
}

inline RTOutSignal RTDInitStatus::Conjugate::rtdCDMportReply( const int & data )
{
	return RTOutSignal( this, Base::rti_rtdCDMportReply, &data, &RTType_int );
}

inline RTOutSignal RTDInitStatus::Conjugate::rtdORBrunningReply( const int & data )
{
	return RTOutSignal( this, Base::rti_rtdORBrunningReply, &data, &RTType_int );
}

inline RTOutSignal RTDInitStatus::Conjugate::rtdORBhandleReply( const long & data )
{
	return RTOutSignal( this, Base::rti_rtdORBhandleReply, &data, &RTType_long );
}

inline RTOutSignal RTDInitStatus::Conjugate::rtdVClimitReply( const int & data )
{
	return RTOutSignal( this, Base::rti_rtdVClimitReply, &data, &RTType_int );
}

inline RTOutSignal RTDInitStatus::Conjugate::rtdAgentActiveReply( const int & data )
{
	return RTOutSignal( this, Base::rti_rtdAgentActiveReply, &data, &RTType_int );
}

inline RTOutSignal RTDInitStatus::Conjugate::rtdLocatorAvailableReply( const int & data )
{
	return RTOutSignal( this, Base::rti_rtdLocatorAvailableReply, &data, &RTType_int );
}

inline RTOutSignal RTDInitStatus::Conjugate::rtdTransportControllerReply( const long & data )
{
	return RTOutSignal( this, Base::rti_rtdTransportControllerReply, &data, &RTType_long );
}

inline RTOutSignal RTDInitStatus::Conjugate::rtdPrimaryEndpointReply( const int & data )
{
	return RTOutSignal( this, Base::rti_rtdPrimaryEndpointReply, &data, &RTType_int );
}

inline RTOutSignal RTDInitStatus::Conjugate::rtdBackupEndpointReply( const int & data )
{
	return RTOutSignal( this, Base::rti_rtdBackupEndpointReply, &data, &RTType_int );
}

#endif /* RTDInitStatus_H */

// }}}RME
