// {{{RME protocolClass 'RTDMediation'

#ifndef RTDMediation_H
#define RTDMediation_H

#ifdef PRAGMA
#pragma interface "RTDMediation.h"
#endif

#include <RTDCompletedSubscriptionData.h>
#include <RTSystem/RTDGatewayMediatorServices.h>
#include <RTDMediatorId.h>
#include <RTDPendingSubscriptionTicket.h>
#include <RTDSubscriptionData.h>
#include <RTDSubscriptionRequest.h>

struct RTDMediation
{
public:
	class Base : public RTRootProtocol
	{
	public:
		enum
		{
			rti_rtdSubscribe = rtiLast_RTRootProtocol + 1,
			rti_rtdPublisherFound,
			rti_rtdPublisherOversubscribed,
			rti_rtdNoPublisher,
			rti_rtdUnsubscribe,
			rti_rtdUnsubscribed,
			rtiLast_RTDMediation = rti_rtdUnsubscribed
		};
		inline RTInSignal rtdSubscribe( void );
		inline RTInSignal rtdPublisherFound( void );
		inline RTInSignal rtdPublisherOversubscribed( void );
		inline RTInSignal rtdNoPublisher( void );
		inline RTInSignal rtdUnsubscribe( void );
		inline RTInSignal rtdUnsubscribed( void );
		inline RTOutSignal rtdSubscribe( const RTTypedValue_RTDSubscriptionRequest & data );
		inline RTOutSignal rtdUnsubscribe( const RTTypedValue_RTDMediatorId & data );
		inline RTOutSignal rtdUnsubscribed( const RTTypedValue_RTDMediatorId & data );
		inline RTOutSignal rtdSubscribeAccepted( const RTTypedValue_RTDMediatorId & data );
		static const RTProtocolDescriptor rt_class;
	};
public:
	class Conjugate : public RTRootProtocol
	{
	public:
		enum
		{
			rti_rtdSubscribe = rtiLast_RTRootProtocol + 1,
			rti_rtdUnsubscribe,
			rti_rtdUnsubscribed,
			rti_rtdSubscribeAccepted,
			rtiLast_RTDMediation = rti_rtdSubscribeAccepted
		};
		inline RTInSignal rtdSubscribe( void );
		inline RTInSignal rtdUnsubscribe( void );
		inline RTInSignal rtdUnsubscribed( void );
		inline RTInSignal rtdSubscribeAccepted( void );
		inline RTOutSignal rtdSubscribe( const RTTypedValue_RTDSubscriptionData & data );
		inline RTOutSignal rtdPublisherFound( const RTTypedValue_RTDCompletedSubscriptionData & data );
		inline RTOutSignal rtdPublisherOversubscribed( const RTTypedValue_RTDPendingSubscriptionTicket & data );
		inline RTOutSignal rtdNoPublisher( const RTTypedValue_RTDPendingSubscriptionTicket & data );
		inline RTOutSignal rtdUnsubscribe( const RTTypedValue_RTDMediatorId & data );
		inline RTOutSignal rtdUnsubscribed( const RTTypedValue_RTDMediatorId & data );
		static const RTProtocolDescriptor rt_class;
	};
};

inline RTInSignal RTDMediation::Base::rtdSubscribe( void )
{
	return RTInSignal( this, rti_rtdSubscribe );
}

inline RTInSignal RTDMediation::Base::rtdPublisherFound( void )
{
	return RTInSignal( this, rti_rtdPublisherFound );
}

inline RTInSignal RTDMediation::Base::rtdPublisherOversubscribed( void )
{
	return RTInSignal( this, rti_rtdPublisherOversubscribed );
}

inline RTInSignal RTDMediation::Base::rtdNoPublisher( void )
{
	return RTInSignal( this, rti_rtdNoPublisher );
}

inline RTInSignal RTDMediation::Base::rtdUnsubscribe( void )
{
	return RTInSignal( this, rti_rtdUnsubscribe );
}

inline RTInSignal RTDMediation::Base::rtdUnsubscribed( void )
{
	return RTInSignal( this, rti_rtdUnsubscribed );
}

inline RTOutSignal RTDMediation::Base::rtdSubscribe( const RTTypedValue_RTDSubscriptionRequest & data )
{
	return RTOutSignal( this, Conjugate::rti_rtdSubscribe, data.data, data.type );
}

inline RTOutSignal RTDMediation::Base::rtdUnsubscribe( const RTTypedValue_RTDMediatorId & data )
{
	return RTOutSignal( this, Conjugate::rti_rtdUnsubscribe, data.data, data.type );
}

inline RTOutSignal RTDMediation::Base::rtdUnsubscribed( const RTTypedValue_RTDMediatorId & data )
{
	return RTOutSignal( this, Conjugate::rti_rtdUnsubscribed, data.data, data.type );
}

inline RTOutSignal RTDMediation::Base::rtdSubscribeAccepted( const RTTypedValue_RTDMediatorId & data )
{
	return RTOutSignal( this, Conjugate::rti_rtdSubscribeAccepted, data.data, data.type );
}

inline RTInSignal RTDMediation::Conjugate::rtdSubscribe( void )
{
	return RTInSignal( this, rti_rtdSubscribe );
}

inline RTInSignal RTDMediation::Conjugate::rtdUnsubscribe( void )
{
	return RTInSignal( this, rti_rtdUnsubscribe );
}

inline RTInSignal RTDMediation::Conjugate::rtdUnsubscribed( void )
{
	return RTInSignal( this, rti_rtdUnsubscribed );
}

inline RTInSignal RTDMediation::Conjugate::rtdSubscribeAccepted( void )
{
	return RTInSignal( this, rti_rtdSubscribeAccepted );
}

inline RTOutSignal RTDMediation::Conjugate::rtdSubscribe( const RTTypedValue_RTDSubscriptionData & data )
{
	return RTOutSignal( this, Base::rti_rtdSubscribe, data.data, data.type );
}

inline RTOutSignal RTDMediation::Conjugate::rtdPublisherFound( const RTTypedValue_RTDCompletedSubscriptionData & data )
{
	return RTOutSignal( this, Base::rti_rtdPublisherFound, data.data, data.type );
}

inline RTOutSignal RTDMediation::Conjugate::rtdPublisherOversubscribed( const RTTypedValue_RTDPendingSubscriptionTicket & data )
{
	return RTOutSignal( this, Base::rti_rtdPublisherOversubscribed, data.data, data.type );
}

inline RTOutSignal RTDMediation::Conjugate::rtdNoPublisher( const RTTypedValue_RTDPendingSubscriptionTicket & data )
{
	return RTOutSignal( this, Base::rti_rtdNoPublisher, data.data, data.type );
}

inline RTOutSignal RTDMediation::Conjugate::rtdUnsubscribe( const RTTypedValue_RTDMediatorId & data )
{
	return RTOutSignal( this, Base::rti_rtdUnsubscribe, data.data, data.type );
}

inline RTOutSignal RTDMediation::Conjugate::rtdUnsubscribed( const RTTypedValue_RTDMediatorId & data )
{
	return RTOutSignal( this, Base::rti_rtdUnsubscribed, data.data, data.type );
}

#endif /* RTDMediation_H */

// }}}RME
