// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool'

#ifndef RTDMemPool_H
#define RTDMemPool_H

#ifdef PRAGMA
#pragma interface "RTDMemPool.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
#include <RTDMemPoolDesc.h>
#include <RTDMemPoolStats.h>
class RTDMemPool;
struct RTDMemPoolInfo;

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
#include <stddef.h>

// }}}USR
// }}}RME

#define RTD_FASTBUF_MAGIC 0xa7b6c5d4

#define RTD_HEADER_SIZE 8

#define RTD_ORDERED_LIST_SIZE 20

class RTDMemPool
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' classAttribute 'poolId'
	int poolId;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' classAttribute 'size'
	int size;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' classAttribute 'magic'
	unsigned int magic;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' classAttribute 'nbOfPools'
	static int nbOfPools;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' classAttribute 'Initialized'
	static bool Initialized;
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' classAttribute 'NbOfBuffers'
	static unsigned NbOfBuffers;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' classAttribute 'buffers'
	static unsigned long buffers[RTD_ORDERED_LIST_SIZE];
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' classAttribute 'bufferAvailability'
	static bool bufferAvailability[RTD_ORDERED_LIST_SIZE];
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' classAttribute 'end'
	static unsigned end;
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' associationEnd 'next'
	RTDMemPool * next;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSUtil::RTDMemoryManagementUtil::RTDMemPoolStats' associationEnd 'poolStats'
	static RTDMemPoolStats poolStats;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSUtil::RTDMemoryManagementUtil::RTDMemPoolInfo' associationEnd 'IndividualStats'
	static RTDMemPoolInfo * IndividualStats;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSUtil::RTDMemoryManagementUtil::RTDMemPoolInfo' associationEnd 'MyPoolInfo'
	static RTDMemPoolInfo * MyPoolInfo;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'init( RTDMemPoolDesc *,int)'
	static int init( RTDMemPoolDesc * initData, int NumPools );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'shutdown()'
	static int shutdown( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'alloc(int,int)'
	static void * alloc( int min_size, int max_size );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'actualSize(void *)'
	static int actualSize( void * pBuf );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'release(void *)'
	static void release( void * pBuf );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'allocExact(int)'
	static void * allocExact( int size );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'allocAny(int)'
	static void * allocAny( int size );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'allocRange(int,int)'
	static void * allocRange( int min_size, int max_size );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'getPoolStats()'
	static const RTDMemPoolStats * getPoolStats( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'clearPoolStats()'
	static void clearPoolStats( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'convertFromVoidPtr(void *)'
	inline static RTDMemPool * convertFromVoidPtr( void * ptr )
	{
		// {{{USR operation 'convertFromVoidPtr(void *)'
		return reinterpret_cast<RTDMemPool *>((int)ptr - (int)sizeof(RTDMemPool));  /** TODO: PR15759 */
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'convertToVoidPtr(RTDMemPool *)'
	inline static void * convertToVoidPtr( RTDMemPool * buffer )
	{
		// {{{USR operation 'convertToVoidPtr(RTDMemPool *)'
		return (void *)((int)buffer + (int)sizeof(RTDMemPool));  /** TODO: PR15759 */
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'isValidFastBuf(RTDMemPool *)'
	inline static int isValidFastBuf( RTDMemPool * buffer )
	{
		// {{{USR operation 'isValidFastBuf(RTDMemPool *)'
		if (buffer->magic != RTD_FASTBUF_MAGIC)
			return -1;

		int id = buffer->poolId;
		if ((id < 0) || (id > nbOfPools))
			return -1;

		return id;

		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'nbOfBuffers()'
	inline static unsigned nbOfBuffers( void )
	{
		// {{{USR operation 'nbOfBuffers()'
		return Initialized ? NbOfBuffers : 0;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'largest(int)'
	static unsigned long largest( int rank = 1 );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'reserve(unsigned long)'
	static void reserve( unsigned long size );
	// }}}RME
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' classAttribute 'HeapMem'
extern void * HeapMem;
// }}}RME

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' operation 'RTD_buf_to_struct(const void *)'
inline RTDMemPool * RTD_buf_to_struct( const void * addr )
{
	// {{{USR operation 'RTD_buf_to_struct(const void *)'
	return reinterpret_cast<RTDMemPool *>(reinterpret_cast<size_t>(addr) - sizeof(RTDMemPool));
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDMemoryManagement::RTDMemPool' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDMemPool_H */

// }}}RME
