// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDMetrics'

#ifndef RTDMetrics_H
#define RTDMetrics_H

#ifdef PRAGMA
#pragma interface "RTDMetrics.h"
#endif

#include <RTSystem/DCS.h>
#include <RTDStats.h>

struct RTDMetrics
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_rtdMetricsCollectOnConfirm = rtiLast_RTRootProtocol + 1,
			rti_rtdMetricsCollectOnFail,
			rti_rtdMetricsCollectOffConfirm,
			rti_rtdMetricsCollectOffFail,
			rti_rtdMetricsClearConfirm,
			rti_rtdMetricsClearFail,
			rti_rtdMetricsIntervalConfirm,
			rti_rtdMetricsIntervalFail,
			rti_rtdMetricsGetConfirm,
			rti_rtdMetricsGetFail
		};

	protected:
		enum { rtiLast_RTDMetrics = rti_rtdMetricsGetFail };

	public:
		inline RTInSignal rtdMetricsCollectOnConfirm( void );
		inline RTInSignal rtdMetricsCollectOnFail( void );
		inline RTInSignal rtdMetricsCollectOffConfirm( void );
		inline RTInSignal rtdMetricsCollectOffFail( void );
		inline RTInSignal rtdMetricsClearConfirm( void );
		inline RTInSignal rtdMetricsClearFail( void );
		inline RTInSignal rtdMetricsIntervalConfirm( void );
		inline RTInSignal rtdMetricsIntervalFail( void );
		inline RTInSignal rtdMetricsGetConfirm( void );
		inline RTInSignal rtdMetricsGetFail( void );
		inline RTOutSignal rtdMetricsCollectOn( const RTTypedValue & value );
		inline RTOutSignal rtdMetricsCollectOn( void );
		inline RTOutSignal rtdMetricsCollectOff( const RTTypedValue & value );
		inline RTOutSignal rtdMetricsCollectOff( void );
		inline RTOutSignal rtdMetricsClear( const RTTypedValue & value );
		inline RTOutSignal rtdMetricsClear( void );
		inline RTOutSignal rtdMetricsInterval( const int & data );
		inline RTOutSignal rtdMetricsGet( const RTTypedValue & value );
		inline RTOutSignal rtdMetricsGet( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_rtdMetricsCollectOn = rtiLast_RTRootProtocol + 1,
			rti_rtdMetricsCollectOff,
			rti_rtdMetricsClear,
			rti_rtdMetricsInterval,
			rti_rtdMetricsGet
		};

	protected:
		enum { rtiLast_RTDMetrics = rti_rtdMetricsGet };

	public:
		inline RTInSignal rtdMetricsCollectOn( void );
		inline RTInSignal rtdMetricsCollectOff( void );
		inline RTInSignal rtdMetricsClear( void );
		inline RTInSignal rtdMetricsInterval( void );
		inline RTInSignal rtdMetricsGet( void );
		inline RTOutSignal rtdMetricsCollectOnConfirm( const RTTypedValue & value );
		inline RTOutSignal rtdMetricsCollectOnConfirm( void );
		inline RTOutSignal rtdMetricsCollectOnFail( const RTTypedValue & value );
		inline RTOutSignal rtdMetricsCollectOnFail( void );
		inline RTOutSignal rtdMetricsCollectOffConfirm( const RTTypedValue & value );
		inline RTOutSignal rtdMetricsCollectOffConfirm( void );
		inline RTOutSignal rtdMetricsCollectOffFail( const RTTypedValue & value );
		inline RTOutSignal rtdMetricsCollectOffFail( void );
		inline RTOutSignal rtdMetricsClearConfirm( const RTTypedValue & value );
		inline RTOutSignal rtdMetricsClearConfirm( void );
		inline RTOutSignal rtdMetricsClearFail( const RTTypedValue & value );
		inline RTOutSignal rtdMetricsClearFail( void );
		inline RTOutSignal rtdMetricsIntervalConfirm( const int & data );
		inline RTOutSignal rtdMetricsIntervalFail( const int & data );
		inline RTOutSignal rtdMetricsGetConfirm( const RTTypedValue_RTDStats & data );
		inline RTOutSignal rtdMetricsGetFail( const RTTypedValue & value );
		inline RTOutSignal rtdMetricsGetFail( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline RTDMetrics::Base::Base( void )
	: RTRootProtocol()
{
}

inline RTDMetrics::Base::~Base( void )
{
}

inline RTInSignal RTDMetrics::Base::rtdMetricsCollectOnConfirm( void )
{
	return RTInSignal( this, rti_rtdMetricsCollectOnConfirm );
}

inline RTInSignal RTDMetrics::Base::rtdMetricsCollectOnFail( void )
{
	return RTInSignal( this, rti_rtdMetricsCollectOnFail );
}

inline RTInSignal RTDMetrics::Base::rtdMetricsCollectOffConfirm( void )
{
	return RTInSignal( this, rti_rtdMetricsCollectOffConfirm );
}

inline RTInSignal RTDMetrics::Base::rtdMetricsCollectOffFail( void )
{
	return RTInSignal( this, rti_rtdMetricsCollectOffFail );
}

inline RTInSignal RTDMetrics::Base::rtdMetricsClearConfirm( void )
{
	return RTInSignal( this, rti_rtdMetricsClearConfirm );
}

inline RTInSignal RTDMetrics::Base::rtdMetricsClearFail( void )
{
	return RTInSignal( this, rti_rtdMetricsClearFail );
}

inline RTInSignal RTDMetrics::Base::rtdMetricsIntervalConfirm( void )
{
	return RTInSignal( this, rti_rtdMetricsIntervalConfirm );
}

inline RTInSignal RTDMetrics::Base::rtdMetricsIntervalFail( void )
{
	return RTInSignal( this, rti_rtdMetricsIntervalFail );
}

inline RTInSignal RTDMetrics::Base::rtdMetricsGetConfirm( void )
{
	return RTInSignal( this, rti_rtdMetricsGetConfirm );
}

inline RTInSignal RTDMetrics::Base::rtdMetricsGetFail( void )
{
	return RTInSignal( this, rti_rtdMetricsGetFail );
}

inline RTOutSignal RTDMetrics::Base::rtdMetricsCollectOn( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdMetricsCollectOn, value.data, value.type );
}

inline RTOutSignal RTDMetrics::Base::rtdMetricsCollectOn( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdMetricsCollectOn, (void *)0, &RTType_void );
}

inline RTOutSignal RTDMetrics::Base::rtdMetricsCollectOff( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdMetricsCollectOff, value.data, value.type );
}

inline RTOutSignal RTDMetrics::Base::rtdMetricsCollectOff( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdMetricsCollectOff, (void *)0, &RTType_void );
}

inline RTOutSignal RTDMetrics::Base::rtdMetricsClear( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdMetricsClear, value.data, value.type );
}

inline RTOutSignal RTDMetrics::Base::rtdMetricsClear( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdMetricsClear, (void *)0, &RTType_void );
}

inline RTOutSignal RTDMetrics::Base::rtdMetricsInterval( const int & data )
{
	return RTOutSignal( this, Conjugate::rti_rtdMetricsInterval, &data, &RTType_int );
}

inline RTOutSignal RTDMetrics::Base::rtdMetricsGet( const RTTypedValue & value )
{
	return RTOutSignal( this, Conjugate::rti_rtdMetricsGet, value.data, value.type );
}

inline RTOutSignal RTDMetrics::Base::rtdMetricsGet( void )
{
	return RTOutSignal( this, Conjugate::rti_rtdMetricsGet, (void *)0, &RTType_void );
}

inline RTDMetrics::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline RTDMetrics::Conjugate::~Conjugate( void )
{
}

inline RTInSignal RTDMetrics::Conjugate::rtdMetricsCollectOn( void )
{
	return RTInSignal( this, rti_rtdMetricsCollectOn );
}

inline RTInSignal RTDMetrics::Conjugate::rtdMetricsCollectOff( void )
{
	return RTInSignal( this, rti_rtdMetricsCollectOff );
}

inline RTInSignal RTDMetrics::Conjugate::rtdMetricsClear( void )
{
	return RTInSignal( this, rti_rtdMetricsClear );
}

inline RTInSignal RTDMetrics::Conjugate::rtdMetricsInterval( void )
{
	return RTInSignal( this, rti_rtdMetricsInterval );
}

inline RTInSignal RTDMetrics::Conjugate::rtdMetricsGet( void )
{
	return RTInSignal( this, rti_rtdMetricsGet );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsCollectOnConfirm( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_rtdMetricsCollectOnConfirm, value.data, value.type );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsCollectOnConfirm( void )
{
	return RTOutSignal( this, Base::rti_rtdMetricsCollectOnConfirm, (void *)0, &RTType_void );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsCollectOnFail( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_rtdMetricsCollectOnFail, value.data, value.type );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsCollectOnFail( void )
{
	return RTOutSignal( this, Base::rti_rtdMetricsCollectOnFail, (void *)0, &RTType_void );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsCollectOffConfirm( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_rtdMetricsCollectOffConfirm, value.data, value.type );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsCollectOffConfirm( void )
{
	return RTOutSignal( this, Base::rti_rtdMetricsCollectOffConfirm, (void *)0, &RTType_void );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsCollectOffFail( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_rtdMetricsCollectOffFail, value.data, value.type );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsCollectOffFail( void )
{
	return RTOutSignal( this, Base::rti_rtdMetricsCollectOffFail, (void *)0, &RTType_void );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsClearConfirm( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_rtdMetricsClearConfirm, value.data, value.type );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsClearConfirm( void )
{
	return RTOutSignal( this, Base::rti_rtdMetricsClearConfirm, (void *)0, &RTType_void );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsClearFail( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_rtdMetricsClearFail, value.data, value.type );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsClearFail( void )
{
	return RTOutSignal( this, Base::rti_rtdMetricsClearFail, (void *)0, &RTType_void );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsIntervalConfirm( const int & data )
{
	return RTOutSignal( this, Base::rti_rtdMetricsIntervalConfirm, &data, &RTType_int );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsIntervalFail( const int & data )
{
	return RTOutSignal( this, Base::rti_rtdMetricsIntervalFail, &data, &RTType_int );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsGetConfirm( const RTTypedValue_RTDStats & data )
{
	return RTOutSignal( this, Base::rti_rtdMetricsGetConfirm, data.data, data.type );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsGetFail( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_rtdMetricsGetFail, value.data, value.type );
}

inline RTOutSignal RTDMetrics::Conjugate::rtdMetricsGetFail( void )
{
	return RTOutSignal( this, Base::rti_rtdMetricsGetFail, (void *)0, &RTType_void );
}

#endif /* RTDMetrics_H */

// }}}RME
