// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection'

#ifndef RTDStatsCollection_H
#define RTDStatsCollection_H

#ifdef PRAGMA
#pragma interface "RTDStatsCollection.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
#include <RTDMetricStats.h>

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// Make sure we only define the stats collection macros if we have included 
// tracing. In other words, these are not the minimal libraries!
#if ((defined RTD_STATISTICS)  && (RTD_STATISTICS == 1))
#	define RTD_MSG_SENT( transport, dataFlag, size, dataSize )	\
		if (RTDStatsCollection::collectingStats()) { \
			RTDStatsCollection::stats->msgSent( (transport), (dataFlag), (size), (dataSize) ); \
		} else ;

#	define RTD_AUDIT_MSG_SENT( transport, size ) \
		if (RTDStatsCollection::collectingStats()) { \
			RTDStatsCollection::stats->msgSent( (transport), (size) ); \
		} else ;
	
#	define RTD_MSG_RECEIVED( transport, dataFlag, size, dataSize ) \
		if (RTDStatsCollection::collectingStats()) { \
			RTDStatsCollection::stats->msgReceived( (transport), (dataFlag), (size), (dataSize) ); \
		} else ;

#	define RTD_AUDIT_MSG_RECEIVED( transport, size ) \
		if (RTDStatsCollection::collectingStats()) { \
			RTDStatsCollection::stats->msgReceived( (transport), (size) ); \
		} else ;

#	define RTD_UPDATE_TRANSPORT_STATS( transport, event ) \
		if (RTDStatsCollection::collectingStats()) { \
			RTDStatsCollection::stats->updateStats( (transport), (event) ); \
		} else ;

#	define RTD_UPDATE_STATS( event ) \
		if (RTDStatsCollection::collectingStats()) { \
			RTDStatsCollection::stats->updateStats( (event) ); \
		} else ;

#	define RTD_UPDATE_CTRL_STATS( event ) \
		if (RTDStatsCollection::collectingStats()) { \
			RTDStatsCollection::stats->updateControllerStats( (event) ); \
		} else ;

#else

#	define RTD_MSG_SENT( transport, dataFlag, size, dataSize )	{}
#	define RTD_AUDIT_MSG_SENT( transport, size ) {}
#	define RTD_MSG_RECEIVED( transport, dataFlag, size, dataSize ) {}
#	define RTD_AUDIT_MSG_RECEIVED( transport, size ) {}
#	define RTD_UPDATE_TRANSPORT_STATS( transport, event ) {}
#	define RTD_UPDATE_STATS( event ) {}
#	define RTD_UPDATE_CTRL_STATS( event ) {}

#endif

// }}}USR
// }}}RME

class RTDStatsCollection
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection' classAttribute 'stats'
	static RTDMetricStats * stats;
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection' classAttribute 'captureStats'
	static int captureStats;
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~RTDStatsCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection' operation 'statsCollectionOff()'
	static void statsCollectionOff( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection' operation 'statsCollectionOn(int)'
	static void statsCollectionOn( int numberTransports );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection' operation 'collectingStats()'
	inline static int collectingStats( void )
	{
		// {{{USR operation 'collectingStats()'
		return captureStats && stats;
		// }}}USR
	}
	// }}}RME
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDStatsCollection' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDStatsCollection_H */

// }}}RME
