// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase'

#ifndef RTDTraceEventBase_H
#define RTDTraceEventBase_H

#ifdef PRAGMA
#pragma interface "RTDTraceEventBase.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
#include <RTDNoTraceArgs.h>
#include <RTDTraceDataDirection.h>
#include <RTDTraceEnums.h>
#include <RTDTraceEventTypes.h>
#include <RTDTraceLevel.h>
#include <RTDTraceSystemHooks.h>
struct RTDTraceDataBlock;

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// Include for logging RTDataObjects
#include    <RTDataObject.h>
#include    <RTTypedValue.h>

// }}}USR
// }}}RME

#define RTD_NO_TAG -1

#define RTD_TRACE_NULL_ARG RTDTraceEventBase::NoTraceArgument

class RTDTraceEventBase
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' classAttribute 'NoTraceArgument'
	static RTDNoTraceArgs NoTraceArgument;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~RTDTraceEventBase( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(char)'
	virtual RTDTraceEventBase & operator <<( char ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(double)'
	virtual RTDTraceEventBase & operator <<( double ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(float)'
	virtual RTDTraceEventBase & operator <<( float ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(int)'
	virtual RTDTraceEventBase & operator <<( int ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(long)'
	virtual RTDTraceEventBase & operator <<( long ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(unsigned long)'
	virtual RTDTraceEventBase & operator <<( unsigned long ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(short)'
	virtual RTDTraceEventBase & operator <<( short ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(unsigned short)'
	virtual RTDTraceEventBase & operator <<( unsigned short ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(unsigned int)'
	virtual RTDTraceEventBase & operator <<( unsigned int ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(const char*)'
	virtual RTDTraceEventBase & operator <<( const char * ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(const void*)'
	virtual RTDTraceEventBase & operator <<( const void * ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(const RTDataObject&)'
	virtual RTDTraceEventBase & operator <<( const RTDataObject & ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(const RTTypedValue&)'
	virtual RTDTraceEventBase & operator <<( const RTTypedValue & ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(const RTDTraceDataBlock&)'
	virtual RTDTraceEventBase & operator <<( const RTDTraceDataBlock & ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator <<(const RTDNoTraceArgs &)'
	virtual RTDTraceEventBase & operator <<( const RTDNoTraceArgs & ) = 0;
	// }}}RME
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' operation 'operator !=(const RTDTraceEventBase &,const RTDTraceEventBase &)'
bool operator !=( const RTDTraceEventBase & lhs, const RTDTraceEventBase & rhs );
// }}}RME

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEventBase' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
#if defined(RTD_TRACE)
    //  The value of RTD_TRACE determines what trace events can be generated as 
    //  per the following table:
    //
    //  RTD_TRACE    EVENTS    SWERRS    SWWARNS   PROTOCOL
    //      0           -         X          X         X
    //      1           X         X          X         X
    //      2           -         -          -         -
    //

    /**  NOTE: These values have been chosen for backward compatibility with v2001.03.00 */

#   if (RTD_TRACE == 0)
#       define  RTD_TRACE_EVENTS_ENABLED    0
#       define  RTD_TRACE_SWERRS_ENABLED    1
#       define  RTD_TRACE_SWWARNS_ENABLED   1
#       define  RTD_TRACE_PROTOCOL_ENABLED  1
#	elif (RTD_TRACE == 1)
#       define  RTD_TRACE_EVENTS_ENABLED    1
#       define  RTD_TRACE_SWERRS_ENABLED    1
#       define  RTD_TRACE_SWWARNS_ENABLED   1
#       define  RTD_TRACE_PROTOCOL_ENABLED  1
#	elif (RTD_TRACE == 2)
#       define  RTD_TRACE_EVENTS_ENABLED    0
#       define  RTD_TRACE_SWERRS_ENABLED    0
#       define  RTD_TRACE_SWWARNS_ENABLED   0
#       define  RTD_TRACE_PROTOCOL_ENABLED  0
#	else
#       error Invalid value for RTD_TRACE
#	endif
#else
	//	Disable all types of tracing.
	//
#   define  RTD_TRACE_EVENTS_ENABLED    0
#   define  RTD_TRACE_SWERRS_ENABLED    0
#   define  RTD_TRACE_SWWARNS_ENABLED   0
#   define  RTD_TRACE_PROTOCOL_ENABLED  0
#endif


#if ((defined RTD_TRACE) && (RTD_TRACE_EVENTS_ENABLED == 1))
#   define RTD_TRACE_EVENT(group,level,info) \
            if(_rtdFilterTraceEvent((group),RTDStandardEvent,(level),-1)) { \
                RTDTraceEventBase * event= _rtdCreateTraceEventBuf((group),RTDStandardEvent,(level), RTD_NO_TAG); \
                * event << info; \
                _rtdLogTraceEvent(*event); \
            }

#   define RTD_TRACE_SWEV(group,level,info) \
			if(_rtdFilterTraceEvent((group), RTDSoftwareDebug,(level),-1)) { \
				RTDTraceEventBase * event= _rtdCreateTraceEventBuf((group), RTDSoftwareDebug,(level), RTD_NO_TAG); \
				*event << __FILE__ << __LINE__ << info; \
				_rtdLogTraceEvent(*event); \
			}
#else
#   define RTD_TRACE_EVENT(group,level,info) {}
#   define RTD_TRACE_SWEV(group,level,info) {}
#endif


#if ((defined RTD_TRACE) && (RTD_TRACE_SWERRS_ENABLED == 1))
#   define RTD_TRACE_SWERR(group,level,info) \
			if(_rtdFilterTraceEvent((group), RTDSoftwareError,(level),-1)) { \
				RTDTraceEventBase * event= _rtdCreateTraceEventBuf((group), RTDSoftwareError,(level), RTD_NO_TAG); \
				*event << info; \
				_rtdLogTraceEvent(*event); \
			}
#else
#   define RTD_TRACE_SWERR(group,level,info) {}
#endif


#if ((defined RTD_TRACE) && (RTD_TRACE_SWWARNS_ENABLED == 1))
#   define RTD_TRACE_SWWARN(group,level,info) \
			if(_rtdFilterTraceEvent((group), RTDSoftwareWarning,(level),-1)) { \
				RTDTraceEventBase * event= _rtdCreateTraceEventBuf((group), RTDSoftwareWarning,(level), RTD_NO_TAG); \
				*event << info; \
				_rtdLogTraceEvent(*event); \
			}
#else
#   define RTD_TRACE_SWWARN(group,level,info) {}
#endif

#if ((defined RTD_TRACE) && (RTD_TRACE_PROTOCOL_ENABLED == 1))
#   define RTD_TRACE_CIRCUIT_DATA(dir,lvc,rvc,signal,prio,encoding,data,len) \
            _rtdTraceCircuitData(dir,lvc,rvc,signal,prio,encoding,data,len)
#else
#   define RTD_TRACE_CIRCUIT_DATA(dir,lvc,rvc,signal,prio,encoding,data,len) {}
#endif


//	NOTE: THE FOLLOWING TRACE INTERFACES ARE FOR RATIONAL INTERNAL USE ONLY.
//
#if ((defined RTD_TRACE) && (RTD_TRACE_PROTOCOL_ENABLED == 1))
#   define RTD_CIRCUIT_TRACE_EVENT(group,level,lvc,rvc,sig,prio,tp,info) \
			if(_rtdFilterTraceEvent((group), RTDProtocolEvent,(level),(lvc))) {\
				RTDTraceEventBase * event= _rtdCreateCircuitTraceEventBuf((group), RTDProtocolEvent,(level),(lvc),(rvc),(sig),(prio),(tp)); \
				*event << info; \
				_rtdLogTraceEvent(*event);\
			}


#   define RTD_TRACE_PROTOCOL_EVENT(group,level,info) \
            if(_rtdFilterTraceEvent((group),RTDProtocolEvent,(level),-1)) { \
                RTDTraceEventBase * event= _rtdCreateTraceEventBuf((group),RTDProtocolEvent,(level), RTD_NO_TAG); \
                * event << info; \
                _rtdLogTraceEvent(*event); \
            }

#   define RTD_TRACE_ENDPORT_DATA(dir,lvc,rvc,signal,prio,data) \
            _rtdTraceEndPortData(dir,lvc,rvc,signal,prio,data)

#else
#   define RTD_TRACE_PROTOCOL_EVENT(group,level,info) {}
#   define RTD_CIRCUIT_TRACE_EVENT(group,level,lvc,rvc,sig,prio,tp,info) {}

#   define RTD_TRACE_ENDPORT_DATA(dir,lvc,rvc,signal,prio,data) {}
#endif


#if ((defined RTD_TRACE) && (RTD_TRACE_EVENTS_ENABLED == 1))                    

#   define RTD_TAG_TRACE_EVENT(group,level,tag,info) \
            if(_rtdFilterTraceEvent((group),RTDStandardEvent,(level),-1)) { \
                RTDTraceEventBase * event= _rtdCreateTraceEventBuf((group),RTDStandardEvent,(level), int(tag)); \
                * event << info; \
                _rtdLogTraceEvent(*event); \
            }

#   define RTD_TAG_TRACE_SWEV(group,level,tag,info) \
			if(_rtdFilterTraceEvent((group), RTDSoftwareDebug,(level),-1)) { \
				RTDTraceEventBase * event= _rtdCreateTraceEventBuf((group), RTDSoftwareDebug,(level), int(tag)); \
				*event << __FILE__ << __LINE__ << info; \
				_rtdLogTraceEvent(*event); \
			}
#else
#   define RTD_TAG_TRACE_EVENT(group,level,tag,info) {}
#   define RTD_TAG_TRACE_SWEV(group,level,tag,info) {}
#endif


#if ((defined RTD_TRACE) && (RTD_TRACE_SWERRS_ENABLED == 1))
#   define RTD_TAG_TRACE_SWERR(group,level,tag,info) \
			if(_rtdFilterTraceEvent((group), RTDSoftwareError,(level),-1)) { \
				RTDTraceEventBase * event= _rtdCreateTraceEventBuf((group), RTDSoftwareError,(level), int(tag)); \
				*event << info; \
				_rtdLogTraceEvent(*event); \
			}
#else
#   define RTD_TAG_TRACE_SWERR(group,level,tag,info) {}
#endif


#if ((defined RTD_TRACE) && (RTD_TRACE_SWWARNS_ENABLED == 1))
#   define RTD_TAG_TRACE_SWWARN(group,level,tag,info) \
			if(_rtdFilterTraceEvent((group), RTDSoftwareWarning,(level),-1)) { \
				RTDTraceEventBase * event= _rtdCreateTraceEventBuf((group), RTDSoftwareWarning,(level), int(tag)); \
				*event << info; \
				_rtdLogTraceEvent(*event); \
			}
#else
#   define RTD_TAG_TRACE_SWWARN(group,level,tag,info) {}
#endif


//	Define internal trace macros for development debugging only.
//
#if ((defined RTD_TRACE_INTERNAL) && (RTD_TRACE_INTERNAL == 1) && (RTD_TRACE == 1))
#	define	RTD_INT_TRACE_EVENT(group,level,info) \
				RTD_TRACE_EVENT(group,level,info)
#	define	RTD_INT_TRACE_PROTOCOL_EVENT(group,level,info) \
				RTD_TRACE_PROTOCOL_EVENT(group,level,info)
#	define	RTD_INT_CIRCUIT_TRACE_EVENT(group,level,lvc,rvc,sig,prio,tp,info) \
				RTD_CIRCUIT_TRACE_EVENT(group,level,lvc,rvc,sig,prio,tp,info)
#	define	RTD_INT_TRACE_SWEV(group,level,info) \
				RTD_TRACE_SWEV(group,level,info)
#   define  RTD_INT_TRACE_SWERR(group,level,info) \
                RTD_TRACE_SWERR(group,level,info)
#   define  RTD_INT_TRACE_SWWARN(group,level,info) \
                RTD_TRACE_SWWARN(group,level,info)
#else
#   define  RTD_INT_TRACE_EVENT(group,level,info)
#   define  RTD_INT_TRACE_PROTOCOL_EVENT(group,level,info)
#   define	RTD_INT_CIRCUIT_TRACE_EVENT(group,level,lvc,rvc,sig,prio,tp,info)
#   define  RTD_INT_TRACE_SWEV(group,level,info)
#   define  RTD_INT_TRACE_SWERR(group,level,info)
#   define  RTD_INT_TRACE_SWWARN(group,level,info)
#endif

// }}}USR
// }}}RME

#endif /* RTDTraceEventBase_H */

// }}}RME
