// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress'

#ifndef RTDTransportAddress_H
#define RTDTransportAddress_H

#ifdef PRAGMA
#pragma interface "RTDTransportAddress.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
#include <RTDResult.h>
#include <RTDTransportId.h>

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
#include "RTMemoryUtil.h"
// }}}USR
// }}}RME

extern const RTObject_class RTType_RTDTransportAddress;

class RTDTransportAddress
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' classAttribute '_transportId'
	RTDTransportId _transportId;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' classAttribute '_endpoint'
	RTString _endpoint;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' classAttribute '_local'
	bool _local;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' classAttribute '_valid'
	bool _valid;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' classAttribute '_isResolved'
	bool _isResolved;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' classAttribute '_originalAddressWasResolved'
	bool _originalAddressWasResolved;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' tool 'OT::Cpp' property 'GenerateDefaultConstructor'
	RTDTransportAddress( void );
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'RTDTransportAddress(const RTDTransportId &,const char * const)'
	RTDTransportAddress( const RTDTransportId & addrTransportId, const char * const addr );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'RTDTransportAddress(const RTDTransportAddress &)'
	RTDTransportAddress( const RTDTransportAddress & rhs );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'transportId()'
	inline RTDTransportId transportId( void ) const
	{
		// {{{USR operation 'transportId()'
		return _transportId;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'endpoint()'
	inline const char * endpoint( void ) const
	{
		// {{{USR operation 'endpoint()'
		return _endpoint;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'operator=(const RTDTransportAddress&)'
	virtual RTDTransportAddress & operator=( const RTDTransportAddress & rhs );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'sameAddress(const RTDTransportAddress &)'
	inline RTDResult sameAddress( const RTDTransportAddress & rhs ) const
	{
		// {{{USR operation 'sameAddress(const RTDTransportAddress &)'
		if ( _transportId == rhs.transportId() )
		{
			if (rhs.isResolved() )
			{
				if ( _isResolved
					&& sameResolved( rhs ) == RTDSuccess )
					return RTDSuccess;
				else
					return RTDFailure;
			}
			else
			{
				if ( !_isResolved
					&& sameUnresolved( rhs ) == RTDSuccess )
					return RTDSuccess;
				else
					return RTDFailure;
			}
		}
		else
			return RTDFailure;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'similarAddress(const RTDTransportAddress &)'
	inline RTDResult similarAddress( const RTDTransportAddress & rhs ) const
	{
		// {{{USR operation 'similarAddress(const RTDTransportAddress &)'
		if ( _transportId == rhs.transportId() )
		{
			if (rhs.isResolved() )
			{
				if ( _isResolved
					&& sameResolved( rhs ) == RTDSuccess )
					return RTDSuccess;
				else
					return RTDFailure;
			}
			else
			{
				if ( sameUnresolved( rhs ) == RTDSuccess )
					return RTDSuccess;
				else
					return RTDFailure;
			}
		}
		else
			return RTDFailure;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'unresolvedName()'
	virtual const char * unresolvedName( void ) const = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'sameUnresolved(const RTDTransportAddress &)'
	RTDResult sameUnresolved( const RTDTransportAddress & rhs ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'originallyResolved()'
	int originallyResolved( void ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'resolve()'
	virtual RTDResult resolve( void ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'setResolved(const RTDTransportAddress &)'
	virtual void setResolved( const RTDTransportAddress & resolvedAddress ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'sameResolved(const RTDTransportAddress &)'
	virtual RTDResult sameResolved( const RTDTransportAddress & rhs ) const = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'isValid()'
	inline int isValid( void ) const
	{
		// {{{USR operation 'isValid()'
		return _valid;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'isResolved()'
	inline int isResolved( void ) const
	{
		// {{{USR operation 'isResolved()'
		return _isResolved;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation 'isLocal()'
	inline int isLocal( void ) const
	{
		// {{{USR operation 'isLocal()'
		return _local;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' operation '~RTDTransportAddress()'
	virtual ~RTDTransportAddress( void );
	// }}}RME
	static const RTFieldDescriptor rtg_RTDTransportAddress_fields[];
};

struct RTTypedValue_RTDTransportAddress
{
	const void * data;
	const RTObject_class * type;
	inline RTTypedValue_RTDTransportAddress( const RTDTransportAddress & rtg_value )
		: data( &rtg_value ), type( &RTType_RTDTransportAddress )
	{
	}
	inline RTTypedValue_RTDTransportAddress( const RTDTransportAddress & rtg_value, const RTObject_class * rtg_type )
		: data( &rtg_value ), type( rtg_type )
	{
	}
	inline ~RTTypedValue_RTDTransportAddress( void )
	{
	}
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportAddress' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDTransportAddress_H */

// }}}RME
