// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint'

#ifndef RTDTransportEndpoint_H
#define RTDTransportEndpoint_H

#ifdef PRAGMA
#pragma interface "RTDTransportEndpoint.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
#include <RTDConnectionId.h>
#include <RTDResult.h>
#include <RTDWriteResult.h>
class RTDAuditHdr;
class RTDDataHdr;
struct RTDMblk;
class RTDTransportAddress;

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class RTDTransportEndpoint
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' classAttribute 'cid'
	RTDConnectionId cid;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' classAttribute 'destination'
	RTDTransportAddress * destination;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' classAttribute 'bound'
	bool bound;
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' tool 'OT::Cpp' property 'GenerateDefaultConstructor'
	inline RTDTransportEndpoint( void )
		: bound( false )
	{
	}
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'RTDTransportEndpoint(const RTDTransportAddress &,const RTDConnectionId &)'
	RTDTransportEndpoint( const RTDTransportAddress & transportAddress, const RTDConnectionId & ourCID );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'CID()'
	inline const RTDConnectionId CID( void ) const
	{
		// {{{USR operation 'CID()'
		return cid;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'CID(const RTDConnectionId &)'
	inline void CID( const RTDConnectionId & updatedCID )
	{
		// {{{USR operation 'CID(const RTDConnectionId &)'
		cid = updatedCID;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'address()'
	inline const RTDTransportAddress * address( void ) const
	{
		// {{{USR operation 'address()'
		return destination;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'updateAddress(const RTDTransportAddress &)'
	virtual void updateAddress( const RTDTransportAddress & reresolvedAddress );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'isBound()'
	int isBound( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'bind()'
	virtual RTDResult bind( void ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'sendData(RTDDataHdr &,const char *,void *,const RTObject_class *)'
	virtual RTDWriteResult sendData( RTDDataHdr & hdr, const char * signalName, void * data, const RTObject_class * type ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'queueData(RTDDataHdr &,const char *,void *,const RTObject_class *,RTDMblk *&,unsigned long &)'
	virtual RTDResult queueData( RTDDataHdr & hdr, const char * signalName, void * data, const RTObject_class * type, RTDMblk * & queuedData, unsigned long & queuedDataSize ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'sendQueueData(RTDDataHdr &,const char *,RTDMblk *,const unsigned long &)'
	virtual RTDWriteResult sendQueueData( RTDDataHdr & hdr, const char * signalName, RTDMblk * data, const unsigned long & dataSize ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'sendAudit(RTDAuditHdr &,void *,const RTObject_class *)'
	virtual RTDWriteResult sendAudit( RTDAuditHdr & hdr, void * data, const RTObject_class * type ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'queueAudit(RTDAuditHdr &,void *,const RTObject_class *,RTDMblk *&,unsigned long &)'
	virtual RTDResult queueAudit( RTDAuditHdr & hdr, void * data, const RTObject_class * type, RTDMblk * & queuedData, unsigned long & queuedDataSize ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'sendQueueAudit(RTDAuditHdr &,RTDMblk *,const unsigned long &)'
	virtual RTDWriteResult sendQueueAudit( RTDAuditHdr & hdr, RTDMblk * data, const unsigned long & dataSize ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation 'reset()'
	virtual void reset( void ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' operation '~RTDTransportEndpoint()'
	virtual ~RTDTransportEndpoint( void );
	// }}}RME
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpoint' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDTransportEndpoint_H */

// }}}RME
