// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile'

#ifndef RTDTransportProfile_H
#define RTDTransportProfile_H

#ifdef PRAGMA
#pragma interface "RTDTransportProfile.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
#include <RTDConnectionAuditConfig.h>
#include <RTDHandshakeAuditConfig.h>
#include <RTDResetAuditConfig.h>
#include <RTDResolveConfig.h>
#include <RTDResult.h>
#include <RTDTransportAddressFactory.h>
#include <RTDTransportAuditTypes.h>
#include <RTDTransportEndpointFactory.h>
#include <RTDTransportId.h>
#include <RTDTransportParameters.h>
#include <RTDTransportRecoveryConfig.h>
class RTDTransport;

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
typedef RTDResult (*RTDAddressValidatorFcn) ( const char * );

typedef void (*RTDCustomControllerFcn) ();
// }}}USR
// }}}RME

class RTDTransportProfile
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'transportName'
	char * transportName;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'totalProtocols'
	int totalProtocols;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'transportProtocols'
	char * * transportProtocols;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'endpointFactory'
	RTDTransportEndpointFactory * endpointFactory;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'addressFactory'
	RTDTransportAddressFactory * addressFactory;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'addressValidator'
	RTDAddressValidatorFcn addressValidator;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'addressTypeDescriptor'
	const RTObject_class * addressTypeDescriptor;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'addressResolutionConfig'
	RTDResolveConfig addressResolutionConfig;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'transportRecoveryConfig'
	RTDTransportRecoveryConfig transportRecoveryConfig;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'periodicAuditType'
	RTDTransportAuditTypes periodicAuditType;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'handshakeAuditConfig'
	RTDHandshakeAuditConfig handshakeAuditConfig;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'connectionAuditConfig'
	RTDConnectionAuditConfig connectionAuditConfig;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'resetAuditConfig'
	RTDResetAuditConfig resetAuditConfig;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'transport'
	RTDTransport * transport;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'customControllerWaitFunction'
	RTDCustomControllerFcn customControllerWaitFunction;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'customControllerWakeupFunction'
	RTDCustomControllerFcn customControllerWakeupFunction;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'customControllerProcessFunction'
	RTDCustomControllerFcn customControllerProcessFunction;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'useCustomController'
	bool useCustomController;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'blockingTransport'
	bool blockingTransport;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'transportId'
	RTDTransportId transportId;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' classAttribute 'parameters'
	RTDTransportParameters parameters;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' tool 'OT::Cpp' property 'GenerateDefaultConstructor'
	RTDTransportProfile( void );
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	RTDTransportProfile & operator=( const RTDTransportProfile & rtg_arg );
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' operation 'RTDTransportProfile(const char *,int,char **,RTDTransport *,RTDTransportId)'
	RTDTransportProfile( const char * name, int totalP, char * * protocolList, RTDTransport * pluginTransport, RTDTransportId id );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' operation 'RTDTransportProfile(const RTDTransportProfile &)'
	RTDTransportProfile( const RTDTransportProfile & copy );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' operation 'validate()'
	int validate( void ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' operation '~RTDTransportProfile()'
	virtual ~RTDTransportProfile( void );
	// }}}RME
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportConfiguration::RTDTransportProfile' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDTransportProfile_H */

// }}}RME
