// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats'

#ifndef RTDTransportStats_H
#define RTDTransportStats_H

#ifdef PRAGMA
#pragma interface "RTDTransportStats.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
#include <stddef.h>

// }}}USR
// }}}RME
// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats::RTDReasons' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

extern const RTObject_class RTType_RTDTransportStats;

class RTDTransportStats
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	enum
	{
	     RTDMaxCounters = 9
	};

	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats::RTDReasons'
	enum RTDReasons
	{
		RTDResolveFailure = 0,
		RTDResolveSuccess = 1,
		RTDBindFailure = 2,
		RTDBindSuccess = 3,
		RTDAuditUnresponsiveFailure = 4,
		RTDAuditResetDetected = 5,
		RTDAuditRecovery = 6,
		RTDWriteFailure = 7,
		RTDTransportRecovery = 8,
		RTDAuditMsgsSent = 9,
		RTDAuditMsgsReceived = 10,
		RTDControlMsgsSent = 11,
		RTDControlMsgsReceived = 12,
		RTDAppMsgsWithDataSent = 13,
		RTDAppMsgsWithDataReceived = 14,
		RTDAppMsgsSignalOnlySent = 15,
		RTDAppMsgsSignalOnlyReceived = 16,
		RTDMaxDataSent = 17,
		RTDMaxDataReceived = 18,
		RTDMinDataSent = 19,
		RTDMinDataReceived = 20,
		RTDBytesSent = 21,
		RTDBytesReceived = 22,
		RTDMaxReasons = 23
	};
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'auditMsgsSent'
	unsigned long auditMsgsSent;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'auditMsgsReceived'
	unsigned long auditMsgsReceived;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'controlMsgsSent'
	unsigned long controlMsgsSent;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'controlMsgsReceived'
	unsigned long controlMsgsReceived;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'appMsgsWithDataSent'
	unsigned long appMsgsWithDataSent;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'appMsgsWithDataReceived'
	unsigned long appMsgsWithDataReceived;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'appMsgsSignalOnlySent'
	unsigned long appMsgsSignalOnlySent;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'appMsgsSignalOnlyReceived'
	unsigned long appMsgsSignalOnlyReceived;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'maxDataSent'
	unsigned long maxDataSent;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'maxDataReceived'
	unsigned long maxDataReceived;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'minDataSent'
	unsigned long minDataSent;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'minDataReceived'
	unsigned long minDataReceived;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'bytesSent'
	unsigned long bytesSent;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'bytesReceived'
	unsigned long bytesReceived;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'counters'
	unsigned long counters[RTDTransportStats::RTDMaxCounters];
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' classAttribute 'transpTag'
	RTString transpTag;
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~RTDTransportStats( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	RTDTransportStats & operator=( const RTDTransportStats & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' operation 'RTDTransportStats()'
	RTDTransportStats( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' operation 'RTDTransportStats(const RTDTransportStats &)'
	RTDTransportStats( const RTDTransportStats & copy );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' operation 'resetStats()'
	void resetStats( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' operation 'msgSent(const unsigned char &,const unsigned long &,const unsigned long &)'
	void msgSent( const unsigned char & dataFlag, const unsigned long & size, const unsigned long & dataSize );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' operation 'msgSent(const unsigned long)'
	inline void msgSent( const unsigned long size )
	{
		// {{{USR operation 'msgSent(const unsigned long)'
		bytesSent += size;
		auditMsgsSent++;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' operation 'msgReceived(const unsigned char &,const unsigned long &,const unsigned long &)'
	void msgReceived( const unsigned char & dataFlag, const unsigned long & size, const unsigned long & dataSize );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' operation 'msgReceived(const unsigned long)'
	inline void msgReceived( const unsigned long size )
	{
		// {{{USR operation 'msgReceived(const unsigned long)'
		bytesReceived += size;
		auditMsgsReceived ++;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' operation 'updateStats(const RTDTransportStats::RTDReasons &)'
	inline void updateStats( const RTDTransportStats::RTDReasons & type )
	{
		// {{{USR operation 'updateStats(const RTDTransportStats::RTDReasons &)'
		counters[type]++;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' operation 'getTransportName()'
	RTString getTransportName( void ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' operation 'getTransportReason(const int)'
	unsigned long getTransportReason( const int reasonIndx ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' operation 'setTransportName(const char *)'
	void setTransportName( const char * newName );
	// }}}RME
	static const RTFieldDescriptor rtg_RTDTransportStats_fields[];
};

struct RTTypedValue_RTDTransportStats
{
	const void * data;
	const RTObject_class * type;
	inline RTTypedValue_RTDTransportStats( const RTDTransportStats & rtg_value )
		: data( &rtg_value ), type( &RTType_RTDTransportStats )
	{
	}
	inline RTTypedValue_RTDTransportStats( const RTDTransportStats & rtg_value, const RTObject_class * rtg_type )
		: data( &rtg_value ), type( rtg_type )
	{
	}
	inline ~RTTypedValue_RTDTransportStats( void )
	{
	}
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME
// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDTransportStats::RTDReasons' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDTransportStats_H */

// }}}RME
